//package util;
public class Complex
{
        public double re;
        public double im;
        public Complex(){}
        public Complex(double re,double im)
        {
            this.re=re;
            this.im=im;
        }
        public void add(Complex comp1,Complex comp2)
        {      this.re=comp1.re+comp2.re; this.im=comp1.im+comp2.im; }
        public void sub(Complex comp1,Complex comp2)
        {      this.re=comp1.re-comp2.re; this.im=comp1.im-comp2.im; }
        public void mul(Complex comp1,Complex comp2)
        {	this.re=(comp1.re*comp2.re)-(comp1.im*comp2.im);
		this.im=(comp1.re*comp2.im)+(comp2.re*comp1.im);
	}
        public void conj(Complex c){
		this.re=c.re; this.im=-c.im;
	}
        public void div(Complex c1,Complex c2)
        {	
		mul(c1,new Complex(c2.re,-c2.im));
		double M=c2.re*c2.re+c2.im*c2.im;
               this.re/=M;
               this.im/=M;
        }
        public void add(Complex comp1)
        {      this.re+=comp1.re; this.im+=comp1.im;}
        public void sub(Complex comp1)
        {      this.re-=comp1.re; this.im=comp1.im; }
        public void mul(Complex comp1)
        {	double r=re*comp1.re-im*comp1.im;
		this.im=re*comp1.im+im*comp1.re;
		this.re=r;
	}
        public void mulAdd(double k,Complex c){
		this.re+=k*c.re;
		this.im+=k*c.im;
	}
        public void conj(){im=-im;}
        public double arg(){
		return Math.atan2(re,im);
	}
	public double mod2(){
		return re*re+im*im;
	}
	public double mod(){
		return Math.sqrt(re*re+im*im);
	}
        public static double arg(Complex c){
		return Math.atan2(c.re,c.im);
	}
        public static Complex div2(Complex c1,Complex c2)
        {	
		double c_re=c1.re*c2.re+c1.im*c2.im,
			c_im=c1.im*c2.re-c2.im*c1.re;
		double M=Math.max(c2.re*c2.re+c2.im*c2.im,Double.MIN_VALUE);
               return new Complex(c_re/M,c_im/M);
        }
	public double dist2(Complex c2){
		return (re-c2.re)*(re-c2.re)+(im-c2.im)*(im-c2.im);
	}
        public String toString()
        {return(re+"+"+im+"i");}
}
