//package util;

public class LPC{

/** Autokoreliacine seka */
public double[] R=null;
/** Tiesines prognozes koeficientai*/
public double[] A=null;
/** Atspindzio koeficientai*/
public double[] K=null;
/** Tiesines prognozes paklaida*/
public double[] Err=null;
/** Tiesines prognozes paklaida naudojant Teiloro aproksimacija*/
public double[] ErrTeilor=null;
private double window=0,lastK=0,lambda=0,mu=2,l_m=lambda+mu, lm=lambda*mu;
private static double preemph=0.95;
private int P;
private double FS=22050;
/** Konstanta 2pi*/
public static final double pi2=Math.PI*2;
/** Ar ignoruoti spktro reiksme taske f=0, sutapatinant su maziausia f reiksme*/
public static boolean killSpect0=true;
/** Ar naudoti Laplaso filtra*/
public static boolean laplace=false;
/** Ar naudoti duomenu periodizavima*/
public static boolean periodize=!true;

/**
FS - imciu daznis, x - duomenys, P - lpc eile<br>
Kvieciamas LPCinit(FS,x,P,0.0,0.0,2.0)
*/
public LPC(double FS, int[] x, int P){
 LPCinit(FS,x,P,0.0,0.0,2.0);
}
/** 
FS - imciu daznis, x - duomenys, P - lpc eile, lastK - paskutinio atspindzio koeficiento reiksme<br>
Kvieciamas LPCinit(FS,x,P,lastK,0.0,2.0)
*/
public LPC(double FS, int[] x, int P, double lastK){
 LPCinit(FS,x,P,lastK,0.0,2.0);
}
/** 
FS - imciu daznis, x - duomenys, P - lpc eile, lastK - paskutinio atspindzio koeficiento reiksme, lambda - fazes keitimo parametras<br>
Kvieciamas LPCinit(FS,x,P,lastK,lambda,2.0)
*/
public LPC(double FS, int[] x, int P, double lastK, double lambda){
 LPCinit(FS,x,P,lastK,lambda,2.0);
}
/** 
FS - imciu daznis, x - duomenys, P - lpc eile, lastK - paskutinio atspindzio koeficiento reiksme, lambda - fazes keitimo parametras, mu - fazes keitimo papildomas parametras<br>
Kvieciamas LPCinit(FS,x,P,lastK,lambda,mu)
*/
public LPC(double FS, int[] x, int P, double lastK, double lambda, double mu){
 LPCinit(FS,x,P,lastK,lambda,mu);
}
/**
window - lango parametras, 
FS - imciu daznis, x - duomenys, P - lpc eile, lastK - paskutinio atspindzio koeficiento reiksme, lambda - fazes keitimo parametras, mu - fazes keitimo papildomas parametras<br>
Kvieciamas LPCinit(FS,x,P,lastK,lambda,mu)
*/
public LPC(double window,double FS, int[] x, int P, double lastK, double lambda, double mu){
 this.window=window;
 LPCinit(FS,x,P,lastK,lambda,mu);
}
/** 
FS - imciu daznis, x - duomenys, P - lpc eile, lastK - paskutinio atspindzio koeficiento reiksme, lambda - fazes keitimo parametras, mu - fazes keitimo papildomas parametras<br>
*/
public void LPCinit(double FS, int[] x, int P, double lastK, double lambda,double mu){
 this.lastK=lastK; this.lambda=lambda; this.mu=mu;
 l_m=lambda+mu; lm=lambda*mu;
 this.P=P; this.FS=FS;
 if (window<=0) R=wAutocorrelate(x,P,lambda); else
	{
	R = new double [P+1];
	double[] r;
  double nf=FS*window;
  int n=2, N=x.length; while ((n*1.5<nf)&&(n*2<N)) n*=2;
  int n2=n/2, sh=0,cnt=0;
  sh=N/2-n2;
  while (sh+n<=N){
	r=wAutocorrelate(my.move(x,sh,sh+n),P,lambda);
	for (int i=0; i<R.length; i++) R[i]+=r[i];
	sh+=n2+N; cnt++;
  }
  cnt=1;
  if (cnt>0) for (int i=0; i<R.length; i++) R[i]/=cnt;
 }
 LevinsonRecursion(P,R);
// getTeilor(x,P);
}
/** Grazina lambda*/
public double getLambda(){ return lambda;}
/** Grazina FS*/
public double getFS(){ return FS;}
/** Grazina P*/
public double getP(){ return P;}
/** LPC i LSP (Linear Spectral Pairs) konvertavimas */
public static double[] LPC2LSP(double[] a,double FS,double lambda){
	System.out.println("lambda="+lambda);
	int P1=a.length, P2=P1+1, n=1024;
	double[] a0=new double[P2], ap=new double[P2];
	int k0=-1, kp=1;
	a0[P1]=-k0; ap[P1]=-kp; a0[0]=a[0]; ap[0]=a[0];
	for (int i=1; i<P1; i++){
		a0[i]=a[i]+k0*a[P1-i];
		ap[i]=a[i]+kp*a[P1-i];
	}
	while (n<16*P1) n<<=1;
	double[] f=new double[n+1];
	for (int i=0; i<n+1; i++) f[i]=i*FS*0.5/n;
//	my.print(a0,"a0"); my.print(ap,"ap");
//	double[] b=LPCPeriodogram(ap,FS,lambda,f,!true);	my.print(b,"b");
	Complex[] b0=LPCComplexPeriodogram(a0,FS,lambda,f);
	Complex[] bp=LPCComplexPeriodogram(ap,FS,lambda,f);
//	my.print(b0,"b0");my.print(bp,"bp");
	double[] s=new double[P2];
	int M=0,m0,m1,mo;
	boolean[] is0=new boolean[P2];
	boolean apd0, apdp;
	double tmp;
	int[] im=new int[P2];
	for (int i=0; i<n; i++){
		apd0=(((b0[i].re*b0[i+1].re)<=0)&&((b0[i].im*b0[i+1].im)<=0));
		apdp=(((bp[i].re*bp[i+1].re)<=0)&&((bp[i].im*bp[i+1].im)<=0));
		if (apd0){
			is0[M]=true; im[M]=i;
			System.out.print("0");				
			s[M++]=interp(b0[i],f[i],b0[i+1],f[i+1]);
		}
		if (apdp){
			is0[M]=!true; im[M]=i;
			System.out.print("p");				
			s[M++]=interp(bp[i],f[i],bp[i+1],f[i+1]);
			if (apd0&&(M>1)&&(s[M-1]<s[M-2])){
				tmp=s[M-1]; s[M-1]=s[M-2]; s[M-2]=tmp;
				is0[M-1]=!is0[M-1]; is0[M-2]=!is0[M-2];
			}
		}
		if ((M>1)&&(is0[M-1]==is0[M-2])){
			m0=im[M-2]; m1=im[M-1]; mo=m1;
			if (is0[M-1]) {for (int m=m0; m<m1; m++)
				if (bp[m].mod2()<bp[mo].mod2()) mo=m;}
			    else {for (int m=m0; m<m1; m++)
				if (b0[m].mod2()<b0[mo].mod2()) mo=m;}
			im[M]=im[M-1]; s[M]=s[M-1]; is0[M]=is0[M-1];
			im[M-1]=mo; s[M-1]=f[mo]; is0[M-1]=!is0[M-1];
			M++;
		}
	}
	System.out.println();
	for (int m=1; m<M; m++) if ((is0[m-1]==is0[m])||(s[m-1]>s[m]))
		System.out.println("Blogai "+m+" "+s[m-1]+" "+f[im[m]]+" "+s[m]+" "+f[im[m]+1]+" "+is0[m-1]+" "+is0[m]+
			" b0: "+b0[im[m]].re+" "+b0[im[m]+1].re+" "+b0[im[m]].im+" "+b0[im[m]+1].im+
			" bp: "+bp[im[m]].re+" "+bp[im[m]+1].re+" "+bp[im[m]].im+" "+bp[im[m]+1].im);
	return s;
}
/** Interpoliavimo darminis metodas*/
public static double interp(Complex z0, double t0, Complex z1, double t1){
	double dx=z1.re-z0.re, dy=z1.im-z0.im, d2=dx*dx+dy*dy;
	if (d2<Double.MIN_VALUE) return (t0+t1)/2;
	double teta=-(z0.re*dx+z0.im*dy)/d2;
	if (teta<0) return t0;
	if (teta>1) return t1;
	return t0+teta*(t1-t0);
}
/** K koeficientu i LPC konvertavimas*/
public static double[] k2LPC(double[] k){
	int P1=k.length+1;
	double[] A0=new double[P1],A1=new double[P1];
	A0[0]=1;
	double w;
	for (int p=1; p<P1; p++){
		w=k[p-1]; A1[p]=-w;
		for (int i=0; i<p; i++) A1[i]=A0[i]+w*A0[p-i];
		A0=my.move(A1);
	}
	return A1;
}
/** LPC koeficientu i K (atspindzio) konvertavimas*/
public static double[] LPC2k(double[] A){
	int P1=A.length;
	double[] A0=new double[P1],k=new double[P1-1],A1=my.move(A);
	double w; A0[0]=1;
	for (int p=P1-1; p>0; p--){
		w=A1[p]; k[p-1]=-w;
		for (int i=1; i<=p; i++) A0[i]=(A1[i]+w*A1[p-i])/(1-w*w);
		A1=my.move(A0);
	}
	return k;
}

// http://www.musicdsp.org/showone.php?id=137
/**
LPC analysis (autocorrelation + Levinson-Durbin recursion)<br>
References : Posted by mail@mutagene.net<br>
--------------------------------------------------------------------------------<br>
Notes : <br>
The autocorrelation function implements a warped autocorrelation,
 so that frequency resolution can be specified by the variable 'lambda'.
 Levinson-Durbin recursion calculates autoregression coefficients a and 
 reflection coefficients (for lattice filter implementation)<br> 
K. Comments for Levinson-Durbin function implement matlab version 
 of the same function.
*/

public static double[] wAutocorrelate(int[] xi, int P, double lambda){
    int L=xi.length, L1=L-1;
//    double[] x=allPass(xi,lambda);
//    for(int i=0; i<L; i++) xi[i]=(int)x[i];
//    double[] x=my.int2double(xi);
	double[] x=new double[L];
    if (laplace){
		for(int i=1; i<L-1; i++) x[i]=xi[i-1]-2*xi[i]+xi[i+1];
	}
    else if (preemph>0){
		for(int i=1; i<L; i++) x[i]=xi[i]-preemph*xi[i-1];
		x[0]=xi[0]-preemph*(2*xi[0]-xi[1]);
	}
	else x=my.int2double(xi);
    double[] dl = new double [L];
    double[] R = new double [P+1];
  if (!periodize){
    double r1=0,r2=0,r1t=0,S=0;
//	geriau ish galo, nes ten mazesnes reiksmes
    for(int k=L1; k>=0;k--){
	    S+=x[k]*x[k];
            dl[k]=r1-lambda*(x[k]-r2);
            r1 = x[k];
            r2 = dl[k];
    }
    R[0]=S;
    for(int i=1; i<=P; i++)
    {
        S=0; r1=0; r2=0;
        for(int k=L1; k>=0;k--){
            S+=dl[k]*x[k];            
            r1t = dl[k];
            dl[k]=r1-lambda*(r1t-r2);
            r1 = r1t;
            r2 = dl[k];
        }
	R[i]=S;
    }
  }
	else{
    double S=0;
    for(int i=0; i<=P; i++)
    {
        S=0; int j;
        for(int k=0; k<L;k++){
		j=k-i; while (j<0) j+=L;
		S+=x[k]*x[j];
        }
	R[i]=S;
    }
  }
    return R;
}
/** Autokoreliacijo sekos skaiciavimas<br>
x - duomenys, P - eile, lambda, mu - fazes perskaiciavimo parametrai*/
public static double[] wAutocorrelate(int[] x, int P, double lambda, double mu){
    int L=x.length;
    double[] R = new double [P+1],
	y=DSP.allPass(DSP.allPass(my.int2double(x),0.0,0.0,lambda),0.0,0.0,mu);
    double x1=0,x2=0,y1=0,y2=0,S=0,y1t,l_m=lambda+mu,lm=lambda*mu;
    for(int k=0; k<L;k++) S+=x[k]*x[k];
    R[0]=S;
    for(int i=1; i<=P; i++)
    {
        S=0;
        for(int k=0; k<L;k++) S+=y[k]*x[k];
	R[i]=S;
	y=DSP.allPass(DSP.allPass(y,0.0,0.0,lambda),0.0,0.0,mu);
    }
    return R;
}
/** Ish liekanos xi grazina duomenis x<br>
Naudinga kompresijai*/
public static int[] getSource(double FS,int[] xi, int P, double lambda){
	boolean saveLaplace=laplace, savePeriodize=periodize;
	laplace=true;	
	LPC lpc=new LPC(FS,xi,P,lambda);
	int L=xi.length,	L1=L-1, L2=L/2;
	int[] s=new int[L];
	int[] y=new int[L];
	double w;
	for (int i=0; i<L; i++){
		w=xi[i];
		for (int m=1; m<=P; m++) if (m<=i) w-=lpc.A[m]*xi[i-m];
		s[i]=(int)w;
	}
/*	for (int i=L2-1; i>=0; i--){
		w=xi[i];
		for (int m=1; m<=P; m++) if (m<=i) w-=lpc.A[m]*xi[i-m];
		s[i]=(int)w;
	}
*/
	double Err=0;
	for (int i=1; i<L1; i++){
		y[i]=1*(s[i-1]-2*s[i]+s[i+1])-0*(xi[i-1]-2*xi[i]+xi[i+1]);
		Err+=(y[i]*y[i]);
	}
	my.println("Err="+Math.sqrt(Err/L));
//	for (int i=1; i<L1; i++) y[i]=y[i	y[0]=
	laplace=saveLaplace;	periodize=savePeriodize;
	return s;
}

/** Apskaiciuoja duomenu x P eiles Teiloro skleidiny<br>
Naudinga duomenu kompresijai*/
public void getTeilor(int[] x, int P){
    int L=x.length;
    double[] dx = new double [L];
    double[] xTeilor = new double [L];
    ErrTeilor = new double [P+1];
    for(int k=0; k<L;k++){
		xTeilor[k]=x[k];
		dx[k]=x[k];
    }
    for(int i=0; i<=P; i++)	for(int k=L-1; k>=0;k--){
	if (k>=i) ErrTeilor[i]+=xTeilor[k]*xTeilor[k];
	if (k>0) dx[k]=dx[k]-dx[k-1];
//	if (Math.abs(xTeilor[k])>Math.abs(dx[k])) xTeilor[k]=dx[k];
	xTeilor[k] = dx[k];
   }
}
/**
Calculate the Levinson-Durbin recursion for the autocorrelation sequence R 
of length P+1 and return the autocorrelation coefficients a 
and reflection coefficients K
*/
//public void LevinsonRecursion(int P, double[] R){
//	LevinsonRecursion(P,R,0);
//}
public void LevinsonRecursion(int P, double[] R)
{
    A=new double[P+1]; K=new double[P+1]; Err=new double[P+1];
    double[] Am1=new double[P+1];
    if(R[0]==0.0) { 
        for(int i=1; i<=P; i++) 
        {
            K[i]=0.0; 
            A[i]=0.0;
        }}
    else {
        double km,Em1,Em;
        int k,s,m;
        for (k=0;k<=P;k++){
            A[0]=0;
            Am1[0]=0; }
        A[0]=1;
        Am1[0]=1;
        km=0;
        Em1=R[0]; Err[0]=Em1;
        for (m=1;m<=P;m++)                    //m=2:N+1
        {
            double err=0.0;                    //err = 0;
            for (k=1;k<=m-1;k++)            //for k=2:m-1
                err += Am1[k]*R[m-k];        // err = err + am1(k)*R(m-k+1);
            km = (R[m]-err)/Em1;            //km=(R(m)-err)/Em1;
		if ((m==P)&&(lastK!=0)) km=lastK;
            K[m-1] = -km;
            A[m]=km;                        //am(m)=km;
            for (k=1;k<=m-1;k++)            //for k=2:m-1
                A[k]=(Am1[k]-km*Am1[m-k]);  // am(k)=am1(k)-km*am1(m-k+1);
            Em=(1-km*km)*Em1;                //Em=(1-km*km)*Em1;
            for(s=0;s<=P;s++)                //for s=1:N+1
                Am1[s] = A[s];                // am1(s) = am(s)
            Em1 = Em;                        //Em1 = Em;
	    Err[m]=Em1;
        }
    }
}
/** Apskaiciuojamas spektras<br>
FS - imciu daznis*/
 public double[] getSpect(int FS){
  if (FS<A.length) my.error("FS<A.length");
  int FS2=FS/2;
  double[] a=new double[FS], u=new double[FS2];
  a[0]=A[0];
  for (int i=1; i<A.length; i++) a[i]=-A[i];
  complexArr uf=fft.fft1d(new complexArr(a));
  double c=10/Math.log(10);
  for (int i=0; i<FS2; i++) u[i]=-Math.log(uf.re[i]*uf.re[i]+uf.im[i]*uf.im[i]+
	Double.MIN_VALUE)*c;
  if (killSpect0) u[0]=u[1];
  return u; 
}
/** Apskaiciuojama x duomenu periodograma (DFFT spektras)*/
 public static double[] getPeriodogram(double[] x){
  int n=1, N=x.length; while (n*2<=N) n*=2;
  int n2=n/2;
  complexArr uf=fft.fft1d(new complexArr(my.move(x,0,n)));
  double c=10/Math.log(10), q=2*Math.log(n);
  double[] u=new double[n2];
  for (int i=0; i<n2; i++) u[i]=(Math.log(uf.re[i]*uf.re[i]+uf.im[i]*uf.im[i]+
	Double.MIN_VALUE)-q)*c;
  if (killSpect0) u[0]=u[1];
  return u;
}
/** Apskaiciuojama x duomenu periodograma (DFFT spektras), naudojant lango parametra*/
 public static double[] getPeriodogram(double[] x, double Window, double FS){
  double nf=FS*Window;
  int n=2, N=x.length; while ((n*1.5<nf)&&(n*2<N)) n*=2;
  int n2=n/2, sh=0,cnt=0;
  double[] Uf=new double[n2],up;
  while (sh+n<=N){
	up=getPeriodogram(my.move(x,sh,sh+n));
	for (int i=0; i<n2; i++) Uf[i]+=up[i];
	sh+=n2; cnt++;
 }
 if (cnt>0) for (int i=0; i<n2; i++) Uf[i]/=cnt;
 return Uf;	
}
/** Grazina x duomenu LPC liekana*/
public double[] getErr(int[] x){
 int n=x.length;
 double[] e=new double[n], y1=new double[P+1], y0=new double[P+1];
 double s, l=lambda, w, E=0;
 for (int i=0; i<n; i++){
	s=0; y0[0]=y1[0]; y1[0]=x[i];
	for (int m=1; m<=P; m++){
		y0[m]=y1[m];y1[m]=l*(y0[m]-y1[m-1])+y0[m-1];
		s+=A[m]*y1[m];
//		if (i>=m) s+=A[m]*x[i-m];
	}
//	e[i]=y1[1];
	e[i]=x[i]-s;
	E+=e[i]*e[i];
 } 
// my.println("Err1="+Math.sqrt(E/n));
 return e;
}
/** Filtravimas keiciantis faze panaudojant lambda parametra*/
public static double[] allPass(int[] x, double lambda){
 int n=x.length;
 double[] y=new double[n];
 y[0]=-lambda*x[0];
 for (int i=1; i<n; i++){
	y[i]=lambda*(y[i-1]-x[i])+x[i-1];
 }
 return y;
}

/** LPC periodograma f dazniuose*/
 public double[] lambdaPeriodogram(double[] f){
  return LPCPeriodogram(A,FS,lambda,f,false);
}
/** LPC periodograma apskaiciuojant naudojant:<br>
A - lpc koefic., FS - imciu dazni, lambda - fazes keitimo parametra, f - dazniu masyvas, re - ar grazinti tik realiaja daly*/
 public static double[] LPCPeriodogram(double[] A, double FS, double lambda, double[] f,
	boolean re){
  int n=f.length;
  Complex[] U=LPCComplexPeriodogram(A,FS,lambda,f);
  double[] u=new double[n];
  for (int i=0; i<n; i++)
	if (re)	u[i]=U[i].re;
	else u[i]=-Math.log(U[i].re*U[i].re+U[i].im*U[i].im+Double.MIN_VALUE)*my.db;
 if (!re&&killSpect0) u[0]=u[1];
//	my.print(u,"u");
  return u;
}

/** Kompleksine LPC periodograma apskaiciuojant naudojant:<br>
A - lpc koefic., FS - imciu dazni, lambda - fazes keitimo parametra, f - dazniu masyvas*/
 public static Complex[] LPCComplexPeriodogram(double[] A, double FS, double lambda, double[] f){
  int n=f.length, P=A.length-1;
  double im,c,s,Q=2*Math.PI/FS,w,mxIm=0;
  Complex[] u=new Complex[n];
  util.Complex C = new util.Complex(),q,S, C0= new util.Complex();
//  my.print(A,"A");
  if ((P<2)||(A[2]<0)) {C0.re=A[1]/2.0; C0.im=Math.sqrt(4-A[1]*A[1])/2;}
		else {C0.re=(A[1]+Math.sqrt(4+A[1]*A[1]))/(-2.0); C0.im=0;}
  double dop=0;
  int io=-1;
  for (int i=0; i<n; i++){
	w=Q*f[i];
	w+=2*Math.atan2(lambda*Math.sin(w),1-lambda*Math.cos(w));
	c=Math.cos(w); s=Math.sin(w);
	S=new util.Complex(A[0],0.0);
	q=new util.Complex(1.0,0.0);
//	C = new util.Complex(1.0,0.0);
	C.div(new util.Complex(c-lambda,-s),new util.Complex(1-lambda*c,-lambda*s));	
//	C.re=c; C.im=-s;
	if ((io<0)||(dop>C0.dist2(C))){ io=i; dop=C0.dist2(C);}
	for (int m=1; m<=P; m++) {
	        q.mul(C);
		S.mulAdd(-A[m],q);
	}
	u[i]=new Complex(S.re,S.im);
 }
  return u;
}

/*
public double cepstMax(double[] x, int P, double lambda, double FS,
	double t0, double t, double t1, int Kiek){
 double[] R=wAutocorrelate(x,P,lambda);
 int m0=(int)(t0*FS), m=(int)(t*FS+0.5), m1=(int)(t1*FS)+1;
 if ((m<m0)||(m>m1)) my.error("(t<t0)||(t>t1) "+t0+" "+t+" "+t1);
 double f=1/t;
 double[] uf=new double[Kiek*3];
 lambdaPeriodogram(new double[]{f-1,f,f+1});
 while
}
*/
/** Kepstro koeficientas<br>
x - duomenys, FS - imciu daznis, t0, t, t1 - kepstro koeficientu laikai,
Kiek - kiek imti t argumentu*/
public static double fftCepst(double[] x, double FS,
	double t0, double t, double t1, int Kiek){
 if ((t<t0)||(t>t1)) my.error("(t<t0)||(t>t1) "+t0+" "+t+" "+t1);
 double h=1/FS, tf=t, p=logFFTsum(x,1/t,FS,Kiek),q;
 while (true){
	q=logFFTsum(x,1/(tf-h),FS,Kiek);
	if ((tf-h<t0)||(q<p)) break;
	tf-=h; p=q;
 }
 if (tf+h/2>t){
    tf=t;
    while (true){
	q=logFFTsum(x,1/(tf+h),FS,Kiek);
	if ((tf+h>t1)||(q<p)) break;
	tf+=h; p=q;
    }
 }
 return tf; 
}
 private static double logFFTsum(double[] u, double f, double FS, int K){
  double q=my.pi2*f/FS,S,sre,sim,Qre,Qim,qre,qim,d;
  int nu=u.length, n=Math.min(nu,(int)(((int)(nu*f/FS))*FS/f+0.5));
  if (n<2) n=nu; int n0=(nu-n)/2, n1=n0+n;
  double qn=1/Math.sqrt(n);
  S=0;
  for (int k=1; k<=K; k++){
	qre=Math.cos(q*k); qim=-Math.sin(q*k);
	Qre=qre; Qim=qim; sre=0; sim=0;
	for (int i=n0; i<n1; i++){
		sre+=Qre*u[i]; sim+=Qim*u[i];
		d=Qre; Qre=Qre*qre-Qim*qim; Qim=d*qim+Qim*qre;	
	}
	S+=Math.log(1+(sre*sre+sim*sim)*qn);
  }
 return S/K;
 }

/** Periodograma, panaudojant lambda ir mu parametrus*/
 public double[] lambdaMuPeriodogram(double[] f){
  int n=f.length;
  double Q=2*Math.PI/FS,w;
  double[] u=new double[n], F=new double[n];
  util.Complex C = new util.Complex(),q,S;
  double f1,f2;
  for (int i=0; i<n; i++){
	f1=Q*f[i]; f2=2*f1;
	w=f2-2*Math.atan2(lm*Math.sin(f2)-l_m*Math.sin(f1),
		1+lm*Math.cos(f2)-l_m*Math.cos(f1));
	F[i]=w*FS;
	S=new util.Complex(A[0],0.0);
	q=new util.Complex(1.0,0.0);
	C.re=Math.cos(w); C.im=-Math.sin(w);
	for (int m=1; m<=P; m++) {
	        q.mul(C);
		S.mulAdd(-A[m],q);
	}
	u[i]=-Math.log(S.re*S.re+S.im*S.im+Double.MIN_VALUE)*my.db;
 }
 for (int i=0; i<n-1; i++) F[i]=F[i+1]-F[i]; F[n-1]=0; my.print(F,"F");
 if (killSpect0) u[0]=u[1];
  return u;
}
/** Periodograma, panaudojant lambda parametra*/
 public double fLambdaMu(double f){
  double f1=2*Math.PI/FS*f, f2=2*f1;
  return f2-2*Math.atan2(lm*Math.sin(f2)-l_m*Math.sin(f1),
		1+lm*Math.cos(f2)-l_m*Math.cos(f1));
 }
/** Daznio f perskaiciavimas panaudojant lambda ir mu*/
 public static double fLambdaMu(double FS,double f,double lambda,double mu){
  double f1=2*Math.PI/FS*f, f2=2*f1,lm=lambda*mu,l_m=lambda+mu;
  return f2-2*Math.atan2(lm*Math.sin(f2)-l_m*Math.sin(f1),
		1+lm*Math.cos(f2)-l_m*Math.cos(f1));
 }
/** Optimaliu lamda ir mu apskaiciavimas duotajam imciu dazniui FS*/
 public static double[] getOptLambdaMu(double FS,double optF){
  int N=100, N1=N/2;
   double h=1.0/N, hf=1.0/FS, o, O=0*Double.MAX_VALUE, L,M,Lo=0,Mo=0,
	f, f1, fo=0;
  for (int l=-N1; l<N; l++){
	L=l*h;
	for (int m=-N1; m<N; m++){
		M=m*h; f=optF*(L*M+1-(L+M))/(2*(1-L*M)); f1=f+1;
		o=Math.abs(fLambdaMu(FS,f-1,L,M)-2*fLambdaMu(FS,f1,L,M)+fLambdaMu(FS,f,L,M));
		if (o>O) {O=o; Lo=L; Mo=M; fo=f;}
	}
		
  }
  
  O*=FS;
  my.println("O="+O+" Lo="+Lo+" Mo="+Mo+" F="+FS*fLambdaMu(FS,fo,Lo,Mo)/pi2+" optF="+optF);
  return new double[]{Lo,Mo,O};
 }
/** Optimalaus lamda apskaiciavimas duotajam imciu dazniui FS*/
// http://www.acoustics.hut.fi/~aqi/wwwPhD/P8.PDF
 public static double getLambda(double FS){
  return (1.0674*Math.sqrt(2/Math.PI*Math.atan(0.06583*FS/1000))-0.1916);
}
/** Optimalaus mu apskaiciavimas duotajam lambda*/
 public static double getMu(double lambda){
  return -1+lambda/(2*lambda+1);
}
// Puikiai apie sinteze
//	http://www.ee.ic.ac.uk/hp/staff/dmb/courses/speech/synth.pdf
// Puikiai apie LPC kvantavima
//	http://www.cs.caltech.edu/~ling/pub/icslp98lsp.pdf
// Linear Spectral Pairs
//	http://www.ee.columbia.edu/~dpwe/e6820/lectures/E6820-L07-coding.pdf
// LPC studentams
//	http://www.data-compression.com/speech.html
// PPT apie speech
// http://www.diku.dk/musinf/courses/asp2003/asp1.pdf
//	Klasikins kalbos nuorodos
//	http://aulos.calarts.edu/pipermail/music-dsp/1999-March/000358.html
//	Yra kalbos apdorojimo detali
//	http://www.kug.ac.at/iem/lehre/arbeiten/hammer.pdf
//	Apie kalbos sinteze
//	http://www.acoustics.hut.fi/~slemmett/dippa/contents.html
//	Kalbos transformacijos
//	http://www.ee.columbia.edu/~dpwe/e6820/newprojects/myt11/ee6820/project/report.pdf
//	Fonem sudarymas
//	http://www.fon.hum.uva.nl/praat/
//	Anil K.Jain - universalus atpazinime	Maltoni - pirshtai
// Kepstrine sinteze
// http://www.electronicsletters.com/papers/2002/0013/paper.asp
}