//package util;
//http://www.nauticom.net/www/jdtaft/JavaFFT.htm
//http://sepwww.stanford.edu/oldsep/hale/FftLab.html fft demo applet

import java.awt.*;
import util.*;

public class fft{

public static int DB=30; // kiek decibelu rodyti (keicia autocorr2)
public static int testCount=0;
public static boolean modeOfEmphCepst=true; // paryskina atiminedamas i/2

public static double meanuofautocorr2;

public static complexArr fft1d(complexArr u){
 int n = u.length;
 double[][] U = new double[n][2];
 for (int i = 0; i < n; i++ ) { U[i][0]=u.re[i]; U[i][1]=u.im[i]; }
 return new complexArr(fft_1d(U));
}
public static double[] cepst(int[] u){
	return cepst(my.int2double(u));
}
public static double[] cepst(double[] u){
 boolean makeDiff=false;
 int nu=u.length, n=2; while ((n<<1)<nu) n=n<<1;
 int n0=(nu-n)/2, n2=n/2+1,i2;
 complexArr uf=fft1d(new complexArr(my.move(u,n0,n0+n)));
 double[] Uf=new double[n],c=new double[n2];
 double eps=0.5/n*0.5/n;
 for (int i=0; i<n2; i++){
	Uf[i]=(n2-i)*Math.log(uf.re[i]*uf.re[i]+uf.im[i]*uf.im[i]+eps);
	if (i!=0) Uf[n-i]=Uf[i];
 }
 uf=ifft1d(new complexArr(Uf));
 c[0]=2*(uf.re[0]*uf.re[0]+uf.re[1]*uf.re[1]);
 c[n2-1]=2*(uf.re[n2-1]*uf.re[n2-1]+uf.re[n2-2]*uf.re[n2-2]);
 for (int i=1; i<n2-1; i++) c[i]=uf.re[i-1]*uf.re[i-1]+2*uf.re[i]*uf.re[i]+uf.re[i+1]*uf.re[i+1];
 if (makeDiff) for (int i=0; i<n2; i++){
	i2=Math.max(Math.min(1,i/2),n2-2);
	c[i]-=(c[i2]+c[i2+1]+c[i2-1])/3;
 }
// c[n2/4]=-300;
// for (int i=0; i<n2; i++) c[i]+=Math.log(c[i]+my.eps);
 return c;
}
public static double[] emphCepst(double[] c, double FS, double deltaT){
 int n=c.length, m=Math.max(1,(int)(deltaT/2*FS));
 double[] w=new double[n];
 for (int i=0; i<n; i++){
//	w[i]=c[i]-my.max(my.move(c,Math.max(0,i/2-m),Math.min(n,i/2+m)));
	w[i]=c[i]-my.max(my.move(c,Math.max(0,i/2-i/8-1),Math.min(n,i/2+i/8+1)))/2;
 }
 return w;
}


public static double[][] cepstrogram(int[] u, double window,
	double minPer, double maxPer, int nx, double FS, double deltaT){
 double minPer0=minPer; minPer=Math.abs(minPer);
 int nu=u.length, i0, i1, t0=(int)(minPer*FS), t1=(int)(maxPer*FS)+1;
 double[][] cg = new double[2][nx];
 int nff=2; while ((nff*1.5<FS*window)&&(4*nff<nu)) nff*=2;
 double[] c,w=new double[nff], uw=new double[nff];
// for (int j=0; j<nff; j++) w[j]=0.54-0.46*Math.cos(j*2*Math.PI/nff);
 for (int j=0; j<nff; j++) w[j]=(1-Math.cos((j+0.5)*2*Math.PI/nff))/2;
// my.println("t01: "+t0+" "+t1+" "+nff);
 for (int j=0; j<nx; j++){
	cg[0][j]=((j+0.5)*nu)/nx/FS;
	i0=(int)Math.round(cg[0][j]*FS)-nff/2; i1=i0+nff;
	if (i1>nu) {i0=nu-nff; i1=nu;}
		else if (i0<0) {i0=0; i1=nff;}
	for (int i=0; i<nff; i++) uw[i]=u[i0+i]*w[i];
	c=cepst(uw);
	if (modeOfEmphCepst) c=emphCepst(c,FS,deltaT);
	int M0=Math.min(t0,c.length-1), M1=Math.min(t1,c.length);
	cg[1][j]=(M0+my.indOfMax(my.move(c,M0,M1)))/FS;
	if (testCount++<-4){	
		my.println(my.indOfAbsMax(my.move(c,M0,M1))+" "+M0+" "+M1+" "+i0+" "+i1);
//		my.print(my.move(c,0,M0),"c0");
//		my.print(my.move(c,M0,c.length),"cM0");
	}
 }
 if (minPer0>0){
   double meanPer=my.median(cg[1]);
   cg=cepstrogram(u,window,-meanPer/1.4,meanPer*1.4,nx,FS,deltaT);
 }
 return cg;
}

public static double[][] cepstrogramFFT(int[] u, double window,
	double minPer, double maxPer, int nx, double FS, double deltaT){
 int Kiek=4;
 double minPer0=minPer; minPer=Math.abs(minPer);
 int nu=u.length, i0, i1, it0=(int)(minPer*FS), it1=(int)(maxPer*FS)+1;
 double[][] cg = new double[2][nx];
 int nFF=2; while (2*nFF<nu) nFF*=2;
 double qf=2*Math.PI/nFF;
 int n0=(nu-nFF)/2;
 double[] uw=new double[nFF];
 for (int j=0; j<nFF; j++) uw[j]=(0.54-0.46*Math.cos(j*qf))*u[n0+j];
 double[] cep=cepst(uw);
 int M0=Math.min(it0,cep.length-1), M1=Math.min(it1,cep.length);
 double meanP=(M0+my.indOfMax(my.move(cep,M0,M1)))/FS,
	t=Math.min(Math.max(minPer,meanP),maxPer);
// my.println("meanPer="+t);
 int nff=Math.min((int)((Kiek+0.5)*t*FS),nu),	nx2=nx/2;
 for (int j=nx2; j<nx; j++){
	cg[0][j]=((j+0.5)*nu)/nx/FS;
	i0=(int)Math.round(cg[0][j]*FS)-nff/2; i1=i0+nff;
	if (i1>nu) {i0=nu-nff; i1=nu;}
		else if (i0<0) {i0=0; i1=nff;}
	t=LPC.fftCepst(my.int2double(my.move(u,i0,i1)),FS,minPer,t,maxPer,Kiek);
	cg[1][j]=t;
 }
 t=cg[1][nx2];
 for (int j=nx2; j>=0; j--){
	cg[0][j]=((j+0.5)*nu)/nx/FS;
	i0=(int)Math.round(cg[0][j]*FS)-nff/2; i1=i0+nff;
	if (i1>nu) {i0=nu-nff; i1=nu;}
		else if (i0<0) {i0=0; i1=nff;}
	t=LPC.fftCepst(my.int2double(my.move(u,i0,i1)),FS,minPer,t,maxPer,Kiek);
	cg[1][j]=t;
 }
 return cg;
}

public static complexArr ifft1d(complexArr uf){
 int n = uf.length;
 double[][] U = new double[n][2];
 for (int i = 0; i < n; i++ ) { U[i][0]=uf.re[i]; U[i][1]=-uf.im[i]; }
 complexArr u = new complexArr(fft_1d(U));
 for (int i = 0; i < n; i++ ) { u.im[i]=-u.im[i]; }
 return u;
}

public static complexArr2 fft2d(int[][] u){
 return fft2d(new complexArr2(u));
}
public static complexArr2 fft2d(complexArr2 u){
 int h=u.h, w=u.w;
// my.print(h,"h"); my.print(w,"w");
 complexArr2 uf = new complexArr2(u.re,u.im);
 for (int i=0; i<h; i++) uf.putRow(i, fft1d(uf.getRow(i)));
 for (int j=0; j<w; j++) uf.putCol(j, fft1d(uf.getCol(j)));
 return uf;
}	
public static complexArr2 ifft2d(complexArr2 uf){
 int h=uf.h, w=uf.w;
// my.print(h,"h"); my.print(w,"w");
 complexArr2 u = new complexArr2(uf.re,uf.im);
 for (int i=0; i<h; i++) u.putRow(i, ifft1d(u.getRow(i)));
 for (int j=0; j<w; j++) u.putCol(j, ifft1d(u.getCol(j)));
 return u;
}	
public static int[] mexHatflt(byte[] u, int w, int h){
int alfa=(255 << 24), R=(255<<16), G=(255<<8), B=(255), Y=R|G;
int [][] flt=new int [][]{
	{ 0,  0, -1, -1, -1,  0,  0},
	{ 0, -1, -3, -3, -3, -1,  0},
	{-1, -3,  0, +7,  0, -3, -1},
	{-1, -3, +7, 24, +7, -3, -1},
	{-1, -3,  0, +7,  0, -3, -1},
	{ 0, -1, -3, -3, -3, -1,  0},
	{ 0,  0, -1, -1, -1,  0,  0}};
 int wh=w*h,w1=wh-1,w2=2*w,w3=3*w;
 int[] U = new int[wh], v = new int[wh], Sw = new int[wh], Sh = new int[wh];;
 for (int i=0; i<wh; i++) U[i]=127-(int)u[i];
 int[] b = new int[wh];
 int n=flt.length; 
// for (int i=0; i<n; i++) for (int j=0; j<n; j++) q+=Math.abs(flt[i][j]);
 for (int i=0; i<wh; i++){
	Sw[i]=U[Math.max(0,i-1)]+U[i]+U[Math.min(w1,i+1)];
	Sh[i]=U[Math.max(0,i-w)]+U[i]+U[Math.min(w1,i+w)];
 }
 int q=0, Q=0;
 for (int i=0; i<wh; i++){ v[i] = 24*U[i]+
	7*(U[Math.max(0,i-1)]+U[Math.min(w1,i+1)]+
		U[Math.max(0,i-w)]+U[Math.min(w1,i+w)])-
	3*(Sh[Math.max(0,i-2)]+Sh[Math.min(w1,i+2)]+
		Sw[Math.max(0,i-w2)]+Sw[Math.min(w1,i+w2)])-
	(Sh[Math.max(0,i-3)]+Sh[Math.min(w1,i+3)]+
		Sw[Math.max(0,i-w3)]+U[i]+Sw[Math.min(w1,i+w3)])-
	(U[Math.max(0,i-2-w2)]+U[Math.min(w1,i-2+w2)]+
		U[Math.max(0,i+2-w2)]+U[Math.min(w1,i+2+w2)]);
	if (Q<v[i]) Q=v[i]; else if (q>v[i]) q=v[i];
 }
 if (Q<-q) Q=-q;
 for (int i=0; i<wh; i++){ q=(255*v[i])/Q;
  if (q>0)
	b[i] = alfa | R | (255-q)<<8| (255-q);
  else b[i] = alfa | (255+q)<<16|G|(255+q);
 }
 return b;
}
public static int[][] corr2(int[][] u, int[][] v){
	boolean test=true;
	int nx=u.length, ny=u[0].length;
	complexArr2 uv = ifft2d(complexMult2(fft2d(new complexArr2(my.int2double(u))),
				conj(fft2d(new complexArr2(my.int2double(v))))));
	if (test) my.println("re: "+my.max(uv.re)+" im: "+my.max(uv.im));
	int[][] iuv=new int[nx][ny];	
	for (int i=0; i<nx; i++) for (int j=0; j<ny; j++)
		iuv[i][j]=(int)Math.round(uv.re[i][j]);
	return iuv;
}
public static int[][] clock2(int[][] u, int[][] v){
	boolean test=true, stable=false;
	int nx=u.length, ny=u[0].length, nxy=nx*ny;
	complexArr2	uf = fft2d(new complexArr2(my.int2double(u))),
			vf = fft2d(new complexArr2(my.int2double(v)));
	Complex c;
	double qu=-1,qv=-1;
	double[] um=new double[nxy], vm=new double[nxy];
	if (stable&&(nx>4)&&(ny>4)){
		for (int i=0; i<nx; i++) for (int j=0; j<ny; j++){
			um[i+j*nx]=uf.re[i][j]*uf.re[i][j]+uf.im[i][j]*uf.im[i][j];
			vm[i+j*nx]=vf.re[i][j]*vf.re[i][j]+vf.im[i][j]*vf.im[i][j];
		}
		int[] iu=my.sort(um), iv=my.sort(vm);
		qu=um[iu[7*nxy/8]];
		qv=vm[iv[7*nxy/8]];
	}
	int ij;
	for (int i=0; i<nx; i++) for (int j=0; j<ny; j++){
		ij=i+j*nx;
		if ((um[ij]>qu)&&(vm[ij]>qv)){
			c=div1(new Complex(vf.re[i][j],vf.im[i][j]),
				new Complex(uf.re[i][j],uf.im[i][j]));		
			uf.re[i][j]=c.re; uf.im[i][j]=c.im;
		}
		else {uf.re[i][j]=0; uf.im[i][j]=0;}
	}
	vf=ifft2d(uf);
	if (test) my.println("re: "+my.max(vf.re)+" im: "+my.max(vf.im));
	int[][] iuv=new int[nx][ny];	
	double Q=1e4;
//	for (int i=0; i<nx; i++) for (int j=0; j<ny; j++)
	for (int i=1; i<nx-1; i++) for (int j=1; j<ny-1; j++)
		iuv[i][j]=(int)Math.round(Q*vf.re[i][j]);
	return iuv;
}
public static Complex div1(Complex c1,Complex c2){
	double	a=(c1.re*c2.re+c1.im*c2.im),
		b=(c2.re*c1.im-c2.im*c1.re),
		q=Math.sqrt(Math.max(a*a+b*b,Double.MIN_VALUE));
	return new Complex(a/q,b/q);
}

public static byte[] autocorr2(byte[] u, int w, int h, int L, int tozero){
// u puse LxL viduriuko autokoreliacija su savimi
 if (tozero==0) DB*=3;
 int trsh=255/4; // kontrasto minimalus dydis kai dar apsimoka slaiciuoti
 int wh=w*h, L2=L/2, L4=L2/2;
 byte[] b = new byte[wh];
 double[] C = new double[L*L];
 float[] c = new float[wh];
 double[][] Ure = new double[L][L];
 double[][] ure = new double[L][L];
 boolean[][] B = new boolean[L][L];
 int iB = 0, R2=L2*L2;
 for (int i=0; i<L; i++) for (int j=0; j<L; j++)
	if (((i-L2)*(i-L2)+(j-L2)*(j-L2))<=R2) { iB+=1; B[i][j]=true;} else B[i][j]=false;
 double s,S;
 int p,umx,umi;
 complexArr2 uc; 
 int I,J=(h%L)/2,ii,jj,ij,II=0,JJ=0;
 I=(w%L)/2; while (I+L<=w) {II+=1; I+=L;}
 J=(h%L)/2; while (J+L<=h) {JJ+=1; J+=L;}
 double[][] cmax = new double[II][JJ], cmin = new double[II][JJ];
 double Cmax=0;

 J=(h%L)/2; S = 0; jj=0;
 while (J+L<=h){
  I=(w%L)/2; ii=0;
  while (I+L<=w) {
	umx=tozero-(int)u[I+L2+(L2+J)*w]; umi=umx; s=0;
	for (int i=0; i<L; i++) for (int j=0; j<L; j++){	
		Ure[i][j]=tozero-(int)u[I+i+(j+J)*w];
		if (B[i][j]){
			p = (int)Ure[i][j];
			s+=p;
			if (umx<p) umx=p; else if (umi>p) umi=p;
			ure[i][j]=p;
		}
	}
//	my.print(new int[]{umx,umi,umx-umi,trsh},"umx,umi,umx-umi,trsh");
	if (umx-umi>trsh){
		s/=iB;
		if (S<s) S=s;
//		my.print(new int[]{(int)umx,(int)umi,(int)((umx+umi)/2),(int)s},"umx,umi,(umx+umi)/2,s");
		uc = ifft2d(complexMult2(fft2d(new complexArr2(Ure)),
						conj(fft2d(new complexArr2(ure)))));
//		for (int i=0; i<L; i++) for (int j=0; j<L; j++) C[I+(i+L2)%L+((j+L2)%L+J)*w] = uc.re[i][j];
		for (int i=0; i<L; i++) for (int j=0; j<L; j++) {
			C[i+j*L] = uc.re[i][j]; c[I+(i+L2)%L+((j+L2)%L+J)*w]=(float)C[i+j*L];
		}
		cmax[ii][jj] = my.max(C)+1; Cmax=Math.max(Cmax,cmax[ii][jj]);
		cmin[ii][jj] = my.min(C);
	}
/*
	Cmin=Cmax*Math.exp(-DB/10/my.log10);
	double q = Math.log(Cmax/Cmin);
	for (int i=0; i<L; i++) for (int j=0; j<L; j++) b[I+(i+L2)%L+((j+L2)%L+J)*w] = (byte) (Math.log(Math.max(1,C[i+j*L]/Cmin))/q*255-128);
*/

	I+=L; ii+=1;
  }
  J+=L; jj+=1;
 }
 for (ii=0; ii<II; ii++) for (jj=0; jj<JJ; jj++) if (cmax[ii][jj]>0){	
	double cmx=(8*cmax[ii][jj]+Cmax)/9;
	double cmi=cmx*Math.exp(-DB/10/my.log10);
	double q = Math.log(cmx/cmi);
	I=(w%L)/2+ii*L; J=(h%L)/2+jj*L;
	if (cmi+1<cmin[ii][jj]){
		double pp=(cmax[ii][jj]-cmi)/(cmax[ii][jj]-cmin[ii][jj]);
		for (int i=0; i<L; i++) for (int j=0; j<L; j++){
			ij = I+i+(j+J)*w; c[ij] = (float)(pp*(c[ij]-cmin[ii][jj])+cmi);
		}
	}
	for (int i=0; i<L; i++) for (int j=0; j<L; j++){
		ij = I+i+(j+J)*w;
		b[ij] = (byte) (Math.log(Math.max(1,c[ij]/cmi))/q*255-128);
	}
 }
 meanuofautocorr2 = S;
 my.print((int) S,"meanuofautocorr2");
/*
 double Cmax = my.max(C), Cmin=Cmax*Math.exp(-DB/10/my.log10);
 double q = Math.log(Cmax/Cmin);
 for (int i=0; i<wh; i++) b[i] = (byte) (Math.log(Math.max(1,C[i]/Cmin))/q*255-128);
*/
 if (tozero==0) DB/=3;
 return b;
}

public static byte[] autocorr2(int[] u, int w, int h, int L){
 return autocorr2(int2byte(u),w,h,L,0);
}


public static byte[] int2byte(int[] u){
 int n=u.length, r, g, G=(255<<8),B=255,j,q;
 byte[] b = new byte[n];
 for (int i=0; i<n; i++){
	j = u[i]; if ((j&G)==G)	b[i]=(byte)(((j&B)-B)/2);
		else b[i]=(byte)((B-(j&B))/2);
	}
// if (q>0){ b[i] = alfa | R | (255-q)<<8| (255-q);
//	  else b[i] = alfa | (255+q)<<16|G|(255+q);
 return b;
}

public static double[][] fft_1d( double[][] array )
{
	double  u_r,u_i, w_r,w_i, t_r,t_i;
	int     ln, nv2, k, l, le, le1, j, ip, i, n;

	n = array.length;
    	ln = (int)( Math.log( (double)n )/Math.log(2) + 0.5 );
	if (n!=1<<ln) my.error("fft: ne dvejeto laipsnis "+n);
    	nv2 = n / 2;
    	j = 1;
 	for (i = 1; i < n; i++ )
    	{
		if (i < j)
		{
	    		t_r = array[i - 1][0];
	    		t_i = array[i - 1][1];
	    		array[i - 1][0] = array[j - 1][0];
	    		array[i - 1][1] = array[j - 1][1];
	    		array[j - 1][0] = t_r;
	    		array[j - 1][1] = t_i;
		}
		k = nv2;
		while (k < j)
		{
	    		j = j - k;
	    		k = k / 2;
		}
		j = j + k;
    	}

 	for (l = 1; l <= ln; l++) /* loops thru stages */
    	{	
     	 	le = (int)(Math.exp( (double)l * Math.log(2) ) + 0.5 );
	  	le1 = le / 2;
		u_r = 1.0;
		u_i = 0.0;
		w_r =  Math.cos( Math.PI / (double)le1 );
		w_i = -Math.sin( Math.PI / (double)le1 );
		for (j = 1; j <= le1; j++) /* loops thru 1/2 twiddle values per stage */
		{
	    		for (i = j; i <= n; i += le) /* loops thru points per 1/2 twiddle */
	    		{
				ip = i + le1;
				t_r = array[ip - 1][0] * u_r - u_i * array[ip - 1][1];
				t_i = array[ip - 1][1] * u_r + u_i * array[ip - 1][0];

				array[ip - 1][0] = array[i - 1][0] - t_r;
				array[ip - 1][1] = array[i - 1][1] - t_i; 

				array[i - 1][0] =  array[i - 1][0] + t_r;
				array[i - 1][1] =  array[i - 1][1] + t_i;  
	    		} 
	    		t_r = u_r * w_r - w_i * u_i;
	    		u_i = w_r * u_i + w_i * u_r;
	    		u_r = t_r;
		} 
    	}
	double q = ((double) 1)/Math.sqrt((double) n);
	for (i = 0; i < n; i++){ array[i][0] *=q; array[i][1] *=q;}
	return array;
} /* end of FFT_1d */

 public static complexArr2 complexMult2(complexArr2 u, complexArr2 v){
	int h=u.h, w=u.w;
	complexArr2 uv = new complexArr2(h,w);
	for (int i=0; i<h; i++) for (int j=0; j<w; j++){
		uv.re[i][j]=u.re[i][j]*v.re[i][j]-u.im[i][j]*v.im[i][j];
		uv.im[i][j]=u.re[i][j]*v.im[i][j]+u.im[i][j]*v.re[i][j];
	 	}
	return uv;
 }
 public static complexArr2 conj(complexArr2 u){
	int h=u.h, w=u.w;
	complexArr2 v = new complexArr2(h,w);
	for (int i=0; i<h; i++) for (int j=0; j<w; j++){
		v.re[i][j]=u.re[i][j]; v.im[i][j]=-u.im[i][j];
	 	}
	return v;
 }
}


